// ----------------------------------
// Filename      : Resources.java
// Created       : 26/10/1999
// Last modified : 08/04/2003
// Target        : Java VM
// Author        : Sven Maerivoet
//
// All rights reserved.
// Universitaire Instelling Antwerpen
// ----------------------------------

package mitrasim.resources;

import java.awt.*;
import java.io.*;
import java.text.*;
import java.util.*;
import mitrasim.util.*;
import mitrasim.engine3d.*;
import mitrasim.network.*;

/** @author Sven Maerivoet<BR>
    All rights reserved.<BR>
    Universitaire Instelling Antwerpen
*/
public class Resources
{
  // the language definitions
  public static Messages fMessages = null;

  // the network's datastructure
  public static Network fNetwork = null;

	// quick connections
	public static final boolean kDisableAutoConnect = false;

  // the dimensions of the configurator's window
  public static final int fcfgXSize = 800;
  public static final int fcfgYSize = 500;

  // the dimensions of the network-modeler's windows
  public static final int knmDefault800x600XSize   = 800;
  public static final int knmDefault800x600YSize   = 555;
  public static final int knmDefault1024x768XSize  = 1024;
  public static final int knmDefault1024x768YSize  = 725;
  public static final int knmDefault1280x1024XSize = 1280;
  public static final int knmDefault1280x1024YSize = 980;
  public static int       fnmXSize                 = knmDefault800x600XSize;
  public static int       fnmYSize                 = knmDefault800x600YSize;
  public static final int knmDefaultLegendXSize    = 400;
  public static final int knmDefaultLegendYSize    = 260;
  public static int       fnmLegendXSize           = knmDefaultLegendXSize;
  public static int       fnmLegendYSize           = knmDefaultLegendYSize;
  public static int       knmLinkCanvasXSize       = 250;
  public static int       knmLinkCanvasLaneHeight  = 30;

  // all the settings for the network-modeler
  public static final Color    knmBorderColor               = Color.magenta;
  public static final Color    knmAxisColor                 = Color.yellow;
  public static final Color    knmZoomFactorColor           = Color.yellow;
  public static final Color    knmMessageColor              = Color.white;
  public static final Color    knmIDColor                   = Color.white;

  public static final Color    knmOriginNodeColor           = Color.blue;
  public static final Color    knmDestinationNodeColor      = Color.green;
  public static final Color    knmJunctionNodeColor         = Color.white;
  public static final Color    knmBendNodeColor             = Color.lightGray;
  public static final Color    knmEnvironmentNodeColor      = Color.orange;

  public static final Color    knmTunnelLinkColor           = Color.yellow;
  public static final Color    knmHighwayLinkColor          = Color.green;
  public static final Color    knmSeparatedOnRampLinkColor  = Color.blue;
  public static final Color    knmMergedOnRampLinkColor     = Color.cyan;
  public static final Color    knmSeparatedOffRampLinkColor = Color.red;
  public static final Color    knmMergedOffRampLinkColor    = Color.darkGray;
  public static final Color    knmNarrowingLinkColor        = Color.white;
  public static final Color    knmWideningLinkColor         = Color.orange;

  public static final Color    knm0To19SpeedColor           = new Color(255,255,0);
  public static final Color    knm20To39SpeedColor          = new Color(0,255,0);
  public static final Color    knm40To59SpeedColor          = new Color(0,155,155);
  public static final Color    knm60To79SpeedColor          = new Color(0,155,255);
  public static final Color    knm80To99SpeedColor          = new Color(0,0,255);
  public static final Color    knm100To119SpeedColor        = new Color(150,0,155);
  public static final Color    knm120AndUpSpeedColor        = new Color(255,0,0);

  public static final int      knmDefaultPixelsToMove       = 50;
  public static int            fnmPixelsToMove              = knmDefaultPixelsToMove;
  public static final int      knmDefaultSelectionProximity = 50;
  public static int            fnmSelectionProximity        = knmDefaultSelectionProximity;
  public static final boolean  knmDefaultShowAboutBox       = true;
  public static boolean        fnmShowAboutBox              = knmDefaultShowAboutBox;
  public static boolean        fnmShowAxes                  = true;
  public static boolean        fnmShowZoomFactor            = true;
  public static boolean        fnmShowNodes                 = true;
  public static boolean        fnmShowNodeIDs               = false;
  public static boolean        fnmShowLinkIDs               = false;
  public static boolean        fnmSpreadLinkIDs             = true;
  public static boolean        fnmColorLinksAccordingToType = true;
  public static boolean        fnmShowEnvironmentIDs        = true;
  public static final int      knmMinSplineInterpolation    = 3;
  public static int            fnmSplineInterpolation       = 32;

  // the dimensions of the network-viewer's window
  public static final int knvDefault800x600XSize   = 800;
  public static final int knvDefault800x600YSize   = 495;
  public static final int knvDefault1024x768XSize  = 1024;
  public static final int knvDefault1024x768YSize  = 665;
  public static final int knvDefault1280x1024XSize = 1280;
  public static final int knvDefault1280x1024YSize = 920;
  public static int       fnvXSize                 = knvDefault800x600XSize;
  public static int       fnvYSize                 = knvDefault800x600YSize;

  // all the settings for the network-viewer
  public static final Color    knvBorderColor            = Color.magenta;
  public static final Color    knvInformationColor       = Color.yellow;
  public static final Color    knvGridColor              = Color.orange;
  public static final Color    knvIDColor                = Color.white;
  public static final Color    knvBoundingBoxColor       = Color.blue;
  public static final Color    knvAxesColor              = Color.red;
  public static final Color    knvLinkColor              = Color.green;
  public static final Color    knvNodeColor              = Color.blue;
  public static final int      knvDefaultUpdateDelayMs   = 10;
  public static final int      knvDefaultUpdateSteps     = 10;
  public static final boolean  knvDefaultShowAboutBox    = true;
  public static int            fnvUpdateDelayMs          = knvDefaultUpdateDelayMs;
  public static int            fnvUpdateSteps            = knvDefaultUpdateSteps;
  public static boolean        fnvShowAboutBox           = knvDefaultShowAboutBox;
  public static Point3D        fnvViewPoint              = null;
  public static SphericalPoint fnvEyePoint               = null;
  public static boolean        fnvPerspectiveMode        = true;
  public static boolean        fnvShowIDs                = true;
  public static boolean        fnvShowNodes              = true;
  public static boolean        fnvShowLinks              = true;
  public static boolean        fnvRenderSplines          = true;
  public static final int      knvMinSplineInterpolation = 3;
  public static int            fnvSplineInterpolation    = 8;
  public static boolean        fnvShowEnvironment        = true;
  public static final int      knvMinOvalInterpolation   = 8;
  public static int            fnvOvalInterpolation      = 1024;
  public static boolean        fnvShowBoundingBox        = true;
  public static boolean        fnvShowAxes               = true;
  public static boolean        fnvShowGrid               = true;
  public static boolean        fnvPointGridType          = true;
  public static final int      knvMinGridFrequency       = 5;
  public static int            fnvGridFrequency          = 100;
  public static int            fnvGridHeight             = 0;
  public static int            fnvDistanceStepSize       = 250;
  public static int            fnvRotateStepSize         = 5;

  // the dimensions of the remote control's window
  public static final int krcDefault800x600XSize   = 300;
  public static final int krcDefault800x600YSize   = 400;
  public static final int krcDefault1024x768XSize  = 300;
  public static final int krcDefault1024x768YSize  = 400;
  public static final int krcDefault1280x1024XSize = 300;
  public static final int krcDefault1280x1024YSize = 400;
  public static int       frcXSize                 = krcDefault800x600XSize;
  public static int       frcYSize                 = krcDefault800x600YSize;

  // all the settings for the remote control
  public static final boolean  krcDefaultShowAboutBox = true;
  public static boolean        frcShowAboutBox        = krcDefaultShowAboutBox;

  // the server's log
  public static Report fServerLog = null;

  // all the settings for the simulator
  public static final float ksimCarLength                         = 4.0f;
  public static final float ksimCarWidth                          = 1.6f;
  public static final float ksimCarHeight                         = 1.4f;
  public static final float ksimTruckLength                       = 16.9f;
  public static final float ksimTruckWidth                        = 2.6f;
  public static final float ksimTruckHeight                       = 3.8f;
  public static float       fsimGravitationalConstant             = 9.81f;
  public static float       fsimCarFollowingMinSpaceHeadway       = 0.5f;
  public static float       fsimCarFollowingMinSpaceHeadwayExcess = 1.0f;
  public static float       fsimCarFollowingMinTimeHeadway        = 0.02f;
  public static float       fsimCarFollowingMinTimeHeadwayExcess  = 0.08f;
  public static float       fsimCarFollowingMaxTimeHeadway        = 0.5f;
  public static float       fsimCarFollowingMaxTimeHeadwayExcess  = 0.5f;
  public static float       fsimCarFollowingAlphaMin              = 1.55f;
  public static float       fsimCarFollowingBetaMin               = 1.08f;
  public static float       fsimCarFollowingGammaMin              = 1.20f;
  public static float       fsimCarFollowingAlphaPlus             = 2.15f;
  public static float       fsimCarFollowingBetaPlus              = -1.67f;
  public static float       fsimCarFollowingGammaPlus             = 0.89f;
  public static float       fsimCriticalRampDistance              = 0.75f;
  public static int         fsimPowerOfMLCProbability             = 2;
  public static float       fsimLaneChangingMinLeadGap            = 0.50f;
  public static float       fsimLaneChangingMinLeadGapExcess      = 0.50f;
  public static float       fsimLaneChangingMinLagGap             = 0.70f;
  public static float       fsimLaneChangingMinLagGapExcess       = 1.00f;
  public static int         fsimAllowTrucksOnLanes                = 3;
  public static int         fsimStartTime                         = 0;
  public static int         fsimPercentageMiddleLaneDrivers       = 0;
  public static float       fsimReactionTimeMean                  = 0.0f;
  public static float       fsimReactionTimeStdDev                = 0.0f;
  public static float       fsimReactionTimeMin                   = 0.0f;
  public static float       fsimReactionTimeMax                   = 0.0f;
  public static float       fsimInitialVehicleSpeed               = 0.0f;
  public static int         fsimCycleHoldTime                     = 100;
  public static float       fsimMinSpaceAtEntrance                = 0.0f;
  public static boolean     fsimAggressionAndExcessCoupled        = false;
  public static int         fsimMinTimeLeftDuringOvertaking       = 50;
  public static Vector      fsimRoutingTable                      = null;
  public static Random      fsimRNG                               = null;
  public static Hashtable   fsimLoopDetectors                     = null;

  // the dimensions of the visualizer's window
  public static final int kvisDefault800x600XSize   = 800;
  public static final int kvisDefault800x600YSize   = 555;
  public static final int kvisDefault1024x768XSize  = 1024;
  public static final int kvisDefault1024x768YSize  = 725;
  public static final int kvisDefault1280x1024XSize = 1280;
  public static final int kvisDefault1280x1024YSize = 980;
  public static int       fvisXSize                 = kvisDefault800x600XSize;
  public static int       fvisYSize                 = kvisDefault800x600YSize;
  public static final int kvisDefaultLegendXSize    = 270;
  public static final int kvisDefaultLegendYSize    = 270;
  public static int       fvisLegendXSize           = kvisDefaultLegendXSize;
  public static int       fvisLegendYSize           = kvisDefaultLegendYSize;

  // all the settings for the visualizer
  public static final boolean  kvisDefaultShowAboutBox        = true;
  public static boolean        fvisShowAboutBox               = kvisDefaultShowAboutBox;
  public static boolean        fvisShowTrafficFlow            = true;
  public static boolean        fvisAnimateVehicles            = true;
  public static boolean        fvisShowAverageSpeeds          = false;
  public static boolean        fvisShowDensities              = false;
  public static boolean        fvisShowVehicleInformation     = false;
  public static boolean        fvisShowMoreVehicleDetail      = true;
  public static boolean        fvisColorVehiclesByAggression  = false;
  public static final Color    kvisBorderColor                = Color.red;
  public static Hashtable      fvisViewSpecifications         = null;
  public static String         fvisViewSpecification          = "";
  public static boolean        fvisPerspectiveMode            = true;
  public static int            fvisViewPointX                 = 0;
  public static int            fvisViewPointY                 = 0;
  public static int            fvisViewPointZ                 = 0;
  public static int            fvisEyePointRho                = 0;
  public static int            fvisEyePointPhi                = 0;
  public static int            fvisEyePointTheta              = 0;
  public static int            fvisBoundingBoxMinX            = 0;
  public static int            fvisBoundingBoxMinY            = 0;
  public static int            fvisBoundingBoxMaxX            = 0;
  public static int            fvisBoundingBoxMaxY            = 0;
  public static boolean        fvisShowEnvironment            = true;
  public static long           fvisFrameDelay                 = 0;
  public static final Color    kvisRoadSurfaceColor           = Color.gray;
  public static final Color    kvisRoadExtentColor            = Color.white;
  public static final Color    kvisMarkBendJunctionColor      = Color.lightGray;
  public static final Color    kvisLaneSeparationColor        = Color.lightGray;
  public static final Color    kvisRampSeparationColor        = Color.yellow;
  public static       int      kvisRotateStepSize             = 15;
  public static       int      kvisDistanceStepSize           = 10;
  public static final float    kvisSleeperLength              = 2.42f;
  public static final float    kvisSleeperWidth               = 0.30f;
  public static final float    kvisSleeperDistance            = 0.32f;
  public static final Color    kvisSleeperColor               = Color.darkGray;
  public static final Color    kvisRailroadColor              = Color.gray;
  public static final Color    kvisCarColor                   = new Color(0.4f,0.0f,0.6f);
  public static final Color    kvisTruckColor                 = new Color(0.0f,0.0f,0.95f);
  public static final Color    kvisCarEdgeColor               = new Color(0.8f,0.0f,1.0f);
  public static final Color    kvisTruckEdgeColor             = Color.cyan;
  public static final Color    kvisDOTColor                   = Color.yellow;
  public static final Color    kvisBlinkerColor               = Color.yellow;
  public static boolean        fvisShowLegend                 = false;
  public static String         fvisLicensePlateToTrack        = "MV-";
  public static boolean        fvisTrackingMode               = false;
  public static final boolean  kvisAutoCloseViewSpecification =  true;

  public Resources()
  {
  }

  public void loadConfiguration()
  {
    String LastProperty = "";

    try {
      // try to read from the ini-file
      FileInputStream ConfigurationFile = new FileInputStream("mitrasim2000.ini");
      Properties Configuration = new Properties();
      Configuration.load(ConfigurationFile);

      String Value;

      LastProperty = "NetworkViewerXSize";
      Value = Configuration.getProperty("NetworkViewerXSize");
      if (Value != null) {
        fnvXSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkViewerYSize";
      Value = Configuration.getProperty("NetworkViewerYSize");
      if (Value != null) {
        fnvYSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkViewerUpdateDelayMs";
      Value = Configuration.getProperty("NetworkViewerUpdateDelayMs");
      if (Value != null) {
        fnvUpdateDelayMs = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkViewerUpdateSteps";
      Value = Configuration.getProperty("NetworkViewerUpdateSteps");
      if (Value != null) {
        fnvUpdateSteps = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkViewerShowAboutBox";
      Value = Configuration.getProperty("NetworkViewerShowAboutBox");
      if (Value != null) {
        fnvShowAboutBox = (Boolean.valueOf(Value)).booleanValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerXSize";
      Value = Configuration.getProperty("NetworkModelerXSize");
      if (Value != null) {
        fnmXSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerYSize";
      Value = Configuration.getProperty("NetworkModelerYSize");
      if (Value != null) {
        fnmYSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerLegendXSize";
      Value = Configuration.getProperty("NetworkModelerLegendXSize");
      if (Value != null) {
        fnmLegendXSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerLegendYSize";
      Value = Configuration.getProperty("NetworkModelerLegendYSize");
      if (Value != null) {
        fnmLegendYSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerPixelsToMove";
      Value = Configuration.getProperty("NetworkModelerPixelsToMove");
      if (Value != null) {
        fnmPixelsToMove = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerSelectionProximity";
      Value = Configuration.getProperty("NetworkModelerSelectionProximity");
      if (Value != null) {
        fnmSelectionProximity = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "NetworkModelerShowAboutBox";
      Value = Configuration.getProperty("NetworkModelerShowAboutBox");
      if (Value != null) {
        fnmShowAboutBox = (Boolean.valueOf(Value)).booleanValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "RemoteControlXSize";
      Value = Configuration.getProperty("RemoteControlXSize");
      if (Value != null) {
        frcXSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "RemoteControlYSize";
      Value = Configuration.getProperty("RemoteControlYSize");
      if (Value != null) {
        frcYSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "RemoteControlShowAboutBox";
      Value = Configuration.getProperty("RemoteControlShowAboutBox");
      if (Value != null) {
        frcShowAboutBox = (Boolean.valueOf(Value)).booleanValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "VisualizerXSize";
      Value = Configuration.getProperty("VisualizerXSize");
      if (Value != null) {
        fvisXSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "VisualizerYSize";
      Value = Configuration.getProperty("VisualizerYSize");
      if (Value != null) {
        fvisYSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "VisualizerLegendXSize";
      Value = Configuration.getProperty("VisualizerLegendXSize");
      if (Value != null) {
        fvisLegendXSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "VisualizerLegendYSize";
      Value = Configuration.getProperty("VisualizerLegendYSize");
      if (Value != null) {
        fvisLegendYSize = (Integer.valueOf(Value)).intValue();
      }
      else {
        throw (new Exception());
      }

      LastProperty = "VisualizerShowAboutBox";
      Value = Configuration.getProperty("VisualizerShowAboutBox");
      if (Value != null) {
        fvisShowAboutBox = (Boolean.valueOf(Value)).booleanValue();
      }
      else {
        throw (new Exception());
      }

      ConfigurationFile.close();
    }
    catch (FileNotFoundException e) {
      System.out.println("Error : mitrasim2000.ini not found.");
      System.exit(0); // abort program
    }
    catch (Exception e) {        
      System.out.println("No valid value for key [" + LastProperty + "] found in mitrasim2000.ini.");
      System.exit(0); // abort program
    }
  }

  public void saveConfiguration() throws IOException
  {
    FileOutputStream ConfigurationFile = new FileOutputStream("mitrasim2000.ini");
    PrintWriter Configuration = new PrintWriter(ConfigurationFile);

    String HorizontalLine = "# ----------------------------------";

    Date CurrentDate = new Date();
    String CreatedLine = "# Created  : " +
                         DateFormat.getDateInstance(DateFormat.FULL,Locale.ENGLISH).format(CurrentDate);

    int CreatedLineLength = CreatedLine.length();
    int HorizontalLineLength = HorizontalLine.length();

    if (CreatedLineLength > HorizontalLineLength) {
      for (int i = 1; i <= (CreatedLineLength - HorizontalLineLength); ++i) {
        HorizontalLine += "-";
      }
    }

    Configuration.println(HorizontalLine);
    Configuration.println("# Filename : mitrasim2000.ini");
    Configuration.println(CreatedLine);
    Configuration.println("# Author   : Sven Maerivoet");
    Configuration.println("# Target   : Mitrasim 2000");
    Configuration.println("#");
    Configuration.println("# All rights reserved.");
    Configuration.println("# Universitaire Instelling Antwerpen");
    Configuration.println(HorizontalLine);
    Configuration.println();

    // save the network-viewer's settings
    Configuration.print("NetworkViewerXSize=");
    Configuration.println(fnvXSize);
    Configuration.print("NetworkViewerYSize=");
    Configuration.println(fnvYSize);
    Configuration.print("NetworkViewerUpdateDelayMs=");
    Configuration.println(fnvUpdateDelayMs);
    Configuration.print("NetworkViewerUpdateSteps=");
    Configuration.println(fnvUpdateSteps);
    Configuration.print("NetworkViewerShowAboutBox=");
    Configuration.println(fnvShowAboutBox);

    Configuration.println();

    // save the network-modeler's settings
    Configuration.print("NetworkModelerXSize=");
    Configuration.println(fnmXSize);
    Configuration.print("NetworkModelerYSize=");
    Configuration.println(fnmYSize);
    Configuration.print("NetworkModelerLegendXSize=");
    Configuration.println(fnmLegendXSize);
    Configuration.print("NetworkModelerLegendYSize=");
    Configuration.println(fnmLegendYSize);
    Configuration.print("NetworkModelerPixelsToMove=");
    Configuration.println(fnmPixelsToMove);
    Configuration.print("NetworkModelerSelectionProximity=");
    Configuration.println(fnmSelectionProximity);
    Configuration.print("NetworkModelerShowAboutBox=");
    Configuration.println(fnmShowAboutBox);

    Configuration.println();

    // save the remote control's settings
    Configuration.print("RemoteControlXSize=");
    Configuration.println(frcXSize);
    Configuration.print("RemoteControlYSize=");
    Configuration.println(frcYSize);
    Configuration.print("RemoteControlShowAboutBox=");
    Configuration.println(frcShowAboutBox);

    Configuration.println();

    // save the visualizer's settings
    Configuration.print("VisualizerXSize=");
    Configuration.println(fvisXSize);
    Configuration.print("VisualizerYSize=");
    Configuration.println(fvisYSize);
    Configuration.print("VisualizerLegendXSize=");
    Configuration.println(fvisLegendXSize);
    Configuration.print("VisualizerLegendYSize=");
    Configuration.println(fvisLegendYSize);
    Configuration.print("VisualizerShowAboutBox=");
    Configuration.println(fvisShowAboutBox);

    Configuration.close();
  }
}
