// ----------------------------------
// Filename      : AboutBox.java
// Created       : 26/10/1999
// Last modified : 25/04/2000
// Target        : Java VM
// Author        : Sven Maerivoet
//
// All rights reserved.
// Universitaire Instelling Antwerpen
// ----------------------------------

package mitrasim.util;

import java.awt.*;
import java.awt.event.*;
import mitrasim.resources.*;

/** @author Sven Maerivoet<BR>
    All rights reserved.<BR>
    Universitaire Instelling Antwerpen
*/
public class AboutBox extends Dialog implements WindowListener, ActionListener
{
  private Messages fMessages;

  public AboutBox(Frame parent, String component)
  {
    super(parent);

    fMessages = (new Resources()).fMessages;

    // adjust the windowlayout
    setFont(new Font(fMessages.lookup("textFontName"),Font.PLAIN,14));
    setResizable(false);
    Point Org = parent.getLocation();
    setLocation(Org.x + 20,Org.y + 60);
    setTitle(fMessages.lookup("textAboutWindowTitle"));
    setModal(true);
    setBackground(Color.lightGray);
    setForeground(Color.black);

    setLayout(new BorderLayout());

    Panel UpperPanel = new Panel();
    UpperPanel.setLayout(new GridLayout(3,1));

    UpperPanel.add(new Label("",Label.CENTER));
    Label fLabel = new Label("Mitrasim 2000",Label.CENTER);
    fLabel.setForeground(Color.white);
    fLabel.setFont(new Font(fMessages.lookup("textFontName"),Font.BOLD,28));
    UpperPanel.add(fLabel);
    UpperPanel.add(new Label("Microscopic Traffic Simulator",Label.CENTER));

    Panel LowerPanel = new Panel();
    LowerPanel.setLayout(new GridLayout(5,1,0,15));

    fLabel = new Label("[" + component + "]",Label.CENTER);
    fLabel.setForeground(Color.white);
    fLabel.setFont(new Font(fMessages.lookup("textFontName"),Font.BOLD,20));
    LowerPanel.add(fLabel);
    LowerPanel.add(new Label(fMessages.lookup("textAboutAuthor"),Label.CENTER));
    LowerPanel.add(new Label("Universitaire Instelling Antwerpen",Label.CENTER));
    LowerPanel.add(new Label("URL: http://mitrasim2000.dyns.cx",Label.CENTER));
    Button OkButton = new Button(fMessages.lookup("buttonOk"));
    OkButton.addActionListener(this);
    LowerPanel.add(OkButton);

    add("North",UpperPanel);
    LogoCanvas canvas = new LogoCanvas();
    add("Center",canvas);
    add("South",LowerPanel);

    // add the windowlistener
    addWindowListener(this);

    pack();
    show();
  }

  // methods from the WindowListener-interface
  public void windowOpened(WindowEvent e) { }
  public void windowClosing(WindowEvent e)
  {
    dispose();
  }
  public void windowClosed(WindowEvent e) { }
  public void windowIconified(WindowEvent e) { }
  public void windowDeiconified(WindowEvent e) { }
  public void windowActivated(WindowEvent e) { }
  public void windowDeactivated(WindowEvent e) { }
  
  // method from the ActionListener-interface
  public void actionPerformed(ActionEvent e)
  {
    String Command = e.getActionCommand();

    if (Command.equals(fMessages.lookup("buttonOk"))) {
      windowClosing(null);
    }
  }

  /** @author Sven Maerivoet<BR>
      All rights reserved.<BR>
      Universitaire Instelling Antwerpen
  */
  private class LogoCanvas extends Canvas
  {
    Image fImage;

    public LogoCanvas()
    {
      super();
      fImage = Toolkit.getDefaultToolkit().getImage("M2000Logo.jpg");
      setSize(250,60);
    }

    public void paint(Graphics gr)
    {
      gr.drawImage(fImage,0,0,this);
    } 
  }
}
