// --------------------------------------
// Filename      : ColorInterpolator.java
// Created       : 22/06/2000
// Last modified : 08/04/2003
// Target        : Java VM
// Author        : Sven Maerivoet
//
// All rights reserved.
// Universitaire Instelling Antwerpen
// --------------------------------------

package mitrasim.visualizer;

import java.awt.*;
import java.awt.event.*;

/** @author Sven Maerivoet<BR>
    All rights reserved.<BR>
    Universitaire Instelling Antwerpen
*/
public class ColorInterpolator
{
  public ColorInterpolator()
  {
  }

  public Color interpolate(int value)
  {
    // interpolate a value (normally between 0 and 100) across a part of the spectrum
    // going from red to green to blue

    // crop the value
    if (value < 0) {
      value = 0;
    }
    else if (value > 100) {
      value = 100;
    }

    float Red = 0.0f;
    float Green = 0.0f;
    float Blue = 0.0f;

    if (value < 25) {
      Red = 1.0f;
      float t = value / 25.0f; // t lies in [0,1[
      Green = t;
    }
    else if (value < 50) {
      float t = 1.0f - ((value - 25) / 25.0f); // t lies in [0,1[
      Red = t;
      Green = 1.0f;
    }
    else if (value < 75) {
      Green = 1.0f;
      float t = (value - 50) / 25.0f; // t lies in [0,1[
      Blue = t;
    }
    else if (value < 100) {
      float t = 1.0f - ((value - 75) / 25.0f); // t lies in [0,1[
      Green = t;
      Blue = 0.5f;
    }
    else {
      Blue = 0.5f;
    }

    Color color = new Color(Red,Green,Blue);

    return color;
  }
}
